unit WebMaildm;

interface

uses
  Windows, Messages, SysUtils, Classes, HTTPApp, Winshoes, WinshoeMessage,
  Pop3Winshoe, SMTPWinshoe;

type
  TWebModule1 = class(TWebModule)
    PageProducer1: TPageProducer;
    pop3: TWinshoePOP3;
    smtp: TWinshoeSMTP;
    msg: TWinshoeMessage;
    procedure PageProducer1HTMLTag(Sender: TObject; Tag: TTag;
      const TagString: String; TagParams: TStrings;
      var ReplaceText: String);
    procedure WebModule1WebActionItem2Action(Sender: TObject;
      Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
  private
    { Private declarations }
  public
    procedure SendMail;
  end;

var
  WebModule1: TWebModule1;

implementation

{$R *.DFM}

procedure TWebModule1.PageProducer1HTMLTag(Sender: TObject; Tag: TTag;
  const TagString: String; TagParams: TStrings; var ReplaceText: String);
var
  nmsg: integer;
begin
  if TagString = 'count' then
  begin
    Pop3.Connect;
    nmsg := Pop3.CheckMessages;
    ReplaceText := IntToStr (nmsg);
    Pop3.Disconnect;

    if nmsg < 20 then
      SendMail;
  end;
end;

procedure TWebModule1.SendMail;
begin
  smtp.Connect;
  smtp.Send (msg);
  smtp.disconnect;
end;

procedure TWebModule1.WebModule1WebActionItem2Action(Sender: TObject;
  Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
begin
  SendMail;
  Response.Content := '<h1>Mail sent</h1>';
end;

end.
