unit animform;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    ListBox1: TListBox;
    Memo1: TMemo;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses animform2;

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  Form2.Hide;

  AnimateWindow (Handle, 2000, AW_hide);

  AnimateWindow (Form2.Handle, 2000, Integer (
    ListBox1.Items.Objects [ListBox1.ItemIndex]));
  Form2.Show;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ListBox1.Items.AddObject ('AW_SLIDE', TObject (AW_SLIDE));
  ListBox1.Items.AddObject ('AW_BLEND', TObject (AW_BLEND));
  ListBox1.Items.AddObject ('AW_CENTER', TObject (AW_CENTER));
  ListBox1.Items.AddObject ('AW_HOR_POSITIVE', TObject (AW_HOR_POSITIVE));
  ListBox1.Items.AddObject ('AW_HOR_NEGATIVE', TObject (AW_HOR_NEGATIVE));
  ListBox1.Items.AddObject ('AW_VER_POSITIVE', TObject (AW_VER_POSITIVE));
  ListBox1.Items.AddObject ('AW_VER_NEGATIVE', TObject (AW_VER_NEGATIVE));
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Memo1.Visible := False;
  AnimateWindow (Memo1.Handle, 1000, Integer (
    ListBox1.Items.Objects [ListBox1.ItemIndex]));
  Memo1.Visible := True;
end;

end.
