unit funcustmod;

interface

uses
  Windows, Messages, SysUtils, DsgnIntf, Classes, Graphics, Controls, Forms, Dialogs;

type
  TFunModule = class (TCustomModule)
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
    procedure ValidateComponent(Component: IComponent); override;
  end;

procedure Register;

implementation

uses
  ToolsApi, Shellapi;

procedure TFunModule.ExecuteVerb(Index: Integer);
begin
  inherited;
  case Index of
    0: begin
      with BorlandIDEServices as IOTAModuleServices do
        CurrentModule.GetOwner (0).
          GetProjectBuilder.BuildProject (cmOTAMake, true);
    end;
    1: with BorlandIDEServices as IOTAServices do
      ShowMEssage (GetProductIdentifier);
    2: ShellExecute (0, 'open', pchar( 'http://community.borland.com/' +
      lowercase ((BorlandIDEServices as IOTAServices).GetProductIdentifier) ),
      '', '', 0);
    4: WinExec ('winmine.exe', sw_show);
    5: WinExec ('notepad.exe', sw_show);
  else
    ShowMessage ('Undefined action');
  end;
end;

function TFunModule.GetVerb(Index: Integer): string;
begin
  case Index of
    0: Result := 'Compile';
    1: Result := 'Which tool?';
    2: Result := 'Learn';
    3: Result := '-';
    4: Result := 'Relax';
    5: Result := 'The perfect HTML editor';
  end;
end;

function TFunModule.GetVerbCount: Integer;
begin
  Result := 6;
end;

procedure TFunModule.ValidateComponent(Component: IComponent);
begin
  inherited;
  if Component.GetClassName = 'TButton' then
    raise Exception.Create ('I hate buttons!');
end;

procedure Register;
begin
  RegisterCustomModule (TForm, TFunModule);
end;

initialization
  Application.Title := 'Upside Down Delphi';
{ Application.MainForm.SetBounds (0,
    Screen.Height - Application.MainForm.Height - 28,
    Screen.Width, Screen.Height - 28);}
end.
