unit noth;

interface

uses
  Classes, Controls;

type
  TNothing = class (TGraphicControl)
  public
    constructor Create (Owner: TComponent); override;
  published
    property Width default 50;
    property Height default 50;
    property Align;
    property ShowHint;
    property Visible;
    property OnClick;
    property OnDblClick;
  end;

procedure Register;

implementation

constructor TNothing.Create (Owner: TComponent);
begin
  // call parent class constructor first
  inherited Create (Owner);
  // set the size
  Width := 50;
  Height := 50;
end;

procedure Register;
begin
  RegisterComponents('FunSide', [TNothing]);
end;

end.
